from temu.c.support.objsys import *
from ctypes import *
TEMUSupport = CDLL('libTEMUSupport.so.4')

assemble = TEMUSupport.temu_assemble
assemble.argtypes = [c_void_p, c_char_p]
assemble.restype = c_uint32

disassemble = TEMUSupport.temu_disassemble
disassemble.argtypes = [c_void_p, c_uint32]
disassemble.restype = c_char_p

disassembleAuto = TEMUSupport.temu_disassembleAuto
disassembleAuto.argtypes = [c_void_p, c_uint32]
disassembleAuto.restype = c_char_p

assembleToMemory = TEMUSupport.temu_assembleToMemory
assembleToMemory.argtypes = [c_void_p, c_char_p, c_uint64]
assembleToMemory.restype = None

disassembleMemory = TEMUSupport.temu_disassembleMemory
disassembleMemory.argtypes = [c_void_p, c_uint64]
disassembleMemory.restype = c_char_p

disassembleMemoryAuto = TEMUSupport.temu_disassembleMemoryAuto
disassembleMemoryAuto.argtypes = [c_void_p, c_uint64]
disassembleMemoryAuto.restype = c_char_p

teIFT_String = 0
teIFT_Register = 1
teIFT_Address = 2
teIFT_Displacement = 3
teIFT_Immediate = 4



class InstructionField(Structure):
  pass
InstructionField._fields_ = [ 
    ('Type', c_uint),
    ('Text', c_char_p),
    ('Value', c_int64)  ]


class AssemblerIface(Structure):
  pass
AssemblerIface._fields_ = [ 
    ('assembleInstruction', CFUNCTYPE(c_int, c_void_p, c_int, c_char_p, c_ulong, POINTER(c_uint8))),
    ('disassembleInstruction', CFUNCTYPE(c_char_p, c_void_p, c_int, c_ulong, POINTER(c_uint8))),
    ('disassembleInstructionToFields', CFUNCTYPE(c_int, c_void_p, c_int, c_ulong, POINTER(c_uint8), POINTER(c_ulong), POINTER(POINTER(InstructionField)))),
    ('readInstruction', CFUNCTYPE(c_int, c_void_p, c_int, c_uint, c_uint64, c_uint64, POINTER(c_ulong), POINTER(c_uint8))),
    ('getNumberofInstructionSets', CFUNCTYPE(c_int, c_void_p)),
    ('getMaxInstructionSize', CFUNCTYPE(c_int, c_void_p, c_int)),
    ('getInstructionSetName', CFUNCTYPE(c_char_p, c_void_p, c_int)),
    ('getInstructionSetIndex', CFUNCTYPE(c_int, c_void_p, c_char_p))  ]


class AssemblerIfaceRef(Structure):
  pass
AssemblerIfaceRef._fields_ = [ 
    ('Obj', POINTER(Object)),
    ('Iface', POINTER(AssemblerIface))  ]

class AssemblerIfaceRefArray(Structure):
  pass
AssemblerIfaceRefArray._fields_ = [ 
    ('Size', c_uint32),
    ('Reserved', c_uint32),
    ('Ifaces', POINTER(AssemblerIfaceRef))  ]
from temu.c.support.objsys import *
from ctypes import *
TEMUSupport = CDLL('libTEMUSupport.so.4')

assemble = TEMUSupport.temu_assemble
assemble.argtypes = [c_void_p, c_char_p]
assemble.restype = c_uint32

disassemble = TEMUSupport.temu_disassemble
disassemble.argtypes = [c_void_p, c_uint32]
disassemble.restype = c_char_p

disassembleAuto = TEMUSupport.temu_disassembleAuto
disassembleAuto.argtypes = [c_void_p, c_uint32]
disassembleAuto.restype = c_char_p

assembleToMemory = TEMUSupport.temu_assembleToMemory
assembleToMemory.argtypes = [c_void_p, c_char_p, c_uint64]
assembleToMemory.restype = None

disassembleMemory = TEMUSupport.temu_disassembleMemory
disassembleMemory.argtypes = [c_void_p, c_uint64]
disassembleMemory.restype = c_char_p

disassembleMemoryAuto = TEMUSupport.temu_disassembleMemoryAuto
disassembleMemoryAuto.argtypes = [c_void_p, c_uint64]
disassembleMemoryAuto.restype = c_char_p

teIFT_String = 0
teIFT_Register = 1
teIFT_Address = 2
teIFT_Displacement = 3
teIFT_Immediate = 4



class InstructionField(Structure):
  pass
InstructionField._fields_ = [ 
    ('Type', c_uint),
    ('Text', c_char_p),
    ('Value', c_int64)  ]


class AssemblerIface(Structure):
  pass
AssemblerIface._fields_ = [ 
    ('assembleInstruction', CFUNCTYPE(c_int, c_void_p, c_int, c_char_p, c_ulong, POINTER(c_uint8))),
    ('disassembleInstruction', CFUNCTYPE(c_char_p, c_void_p, c_int, c_ulong, POINTER(c_uint8))),
    ('disassembleInstructionToFields', CFUNCTYPE(c_int, c_void_p, c_int, c_ulong, POINTER(c_uint8), POINTER(c_ulong), POINTER(POINTER(InstructionField)))),
    ('readInstruction', CFUNCTYPE(c_int, c_void_p, c_int, c_uint, c_uint64, c_uint64, POINTER(c_ulong), POINTER(c_uint8))),
    ('getNumberofInstructionSets', CFUNCTYPE(c_int, c_void_p)),
    ('getMaxInstructionSize', CFUNCTYPE(c_int, c_void_p, c_int)),
    ('getInstructionSetName', CFUNCTYPE(c_char_p, c_void_p, c_int)),
    ('getInstructionSetIndex', CFUNCTYPE(c_int, c_void_p, c_char_p))  ]


class AssemblerIfaceRef(Structure):
  pass
AssemblerIfaceRef._fields_ = [ 
    ('Obj', POINTER(Object)),
    ('Iface', POINTER(AssemblerIface))  ]

class AssemblerIfaceRefArray(Structure):
  pass
AssemblerIfaceRefArray._fields_ = [ 
    ('Size', c_uint32),
    ('Reserved', c_uint32),
    ('Ifaces', POINTER(AssemblerIfaceRef))  ]
